#include "animals.h"
#include <iostream>

Animal::Animal(const std::string& name, unsigned int weight)
        : name_(name), weight_(weight)
{ }

void Animal::eat(unsigned int amount)
{
    weight_ += amount;
}

void Animal::play()
{
    std::cout << get_name() << " plays.\n";
}

Cat::Cat(const std::string& name) : Animal(name, 10)
{ }

void Cat::speak()
{
    std::cout << get_name() << " says meow!\n";
}

Dog::Dog(const std::string& name)
        : Animal{name, 50}
        , nbones_{1}
{ }

void Dog::speak()
{
    std::cout << get_name() << " says";
    for (size_t i = 0; i < nbones_; ++i)
        std::cout << " woof";
    std::cout << "!\n";
}

void Dog::play()
{
    Animal::play();
    ++nbones_;
}

void play_twice(Animal&);

int main()
{
    // My mom has four cats and two dogs.
    Dog willie("Willie");
    Cat vinny("Vinny");
    Cat francie("Francie");

    willie.play();
    vinny.play();
    francie.eat(2);
}

void play_twice(Animal& an)
{
    an.play();
    an.play();
}

